---
title: CSSStyleRule.styleMap
slug: Web/API/CSSStyleRule/styleMap
---
<div>{{APIRef("CSSOM")}}{{SeeCompatTable}}</div>

<p class="summary">The <strong><code>styleMap</code></strong> read-only property of the {{domxref("CSSStyleRule")}} interface returns a {{domxref('StylePropertyMap')}} object which provides access to the rule's property-value pairs.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">var stylePropertyMap = <em>cssStyleRule</em>.styleMap;</pre>

<h3 id="Value">Value</h3>

<p>A {{domxref('StylePropertyMap')}} object.</p>

<h2 id="Example">Example</h2>

<p>The following example shows <code>styleMap</code> being used to modify a style using the {{domxref('StylePropertyMap.set()')}} method.</p>

<pre class="brush: js notranslate">const stylesheet = document.styleSheets[0];

Object.values(stylesheet.cssRules).forEach(block =&gt; {

	if (block.selectorText === 'button') {
		block.styleMap.set('--mainColour', 'black');
	}
})</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('CSS Typed OM','#dom-cssstylerule-stylemap','styleMap')}}</td>
   <td>{{Spec2('CSS Typed OM')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.CSSStyleRule.styleMap")}}</p>
